uniform sampler2D texture;
uniform vec2 resolution;

void main(){
	vec2 offset = 1.0 / resolution.xy;
	vec2 texCoord = gl_TexCoord[0].xy;
	vec4 col = texture2D(texture, texCoord);

	if (col.a == 1.0) {
		gl_FragColor = col;

	}else {
		vec4 sampleColour = vec4(0.0, 0.0, 0.0, 1.0);
		int sampleSize = 0;
		float thickness = 4.0;
		float pi = radians(180.0);
		float angle = 0.0;

		while(angle <= pi/2.0) {
			float x = cos(angle) * offset.x * thickness;
			float y = sin(angle) * offset.y * thickness;
			vec4 get;
			
			get = texture2D(texture, vec2(texCoord.x + x, texCoord.y + y));
			if(get.a == 1.0) {
				sampleColour.rgb += get.rgb;
				sampleSize ++;
			}
			
			get = texture2D(texture, vec2(texCoord.x - x, texCoord.y + y));
			if(get.a == 1.0) {
				sampleColour.rgb += get.rgb;
				sampleSize ++;
			}

			get = texture2D(texture, vec2(texCoord.x - x, texCoord.y - y));
			if(get.a == 1.0) {
				sampleColour.rgb += get.rgb;
				sampleSize ++;
			}

			get = texture2D(texture, vec2(texCoord.x + x, texCoord.y - y));
			if(get.a == 1.0) {
				sampleColour.rgb += get.rgb;
				sampleSize ++;
			}

			angle += (2*pi) / 8;
		}

		if(sampleSize > 0) {
			sampleColour.rgb /= sampleSize * 4.0;
			gl_FragColor = sampleColour;
		}
	}
}