uniform sampler2D texture;
uniform vec2 resolution;

void main(){
	vec2 offset = 1.0 / resolution.xy;
	vec2 texCoord = gl_TexCoord[0].xy;
	vec4 col = texture2D(texture, texCoord);

	if (col.a == 1.0) {
		gl_FragColor = col;

	}else {
		vec4 sampleColour = vec4(0.0, 0.0, 0.0, 1.0);
		int sampleSize = 0;
		float thickness = 4.0;

		for(float x = -thickness; x <= thickness; x += 1.0) {
			for(float y = -thickness; y <= thickness; y += 1.0) {
				vec4 get = texture2D(texture, texCoord + vec2(x * offset.x, y * offset.y));

				if(get.a > 0.5) {
					sampleColour += get;
					sampleSize ++;
				}
			}
		}

		if(sampleSize > 0) {
			sampleColour.rgb /= sampleSize * 4.0;
			sampleColour.a = 1.0;
			gl_FragColor = sampleColour;
		}
	}
}